function [exitnow, b, p, i, c] = collide(pac,b,p,i,c)
%[EXITNOW, B, P, I, C] = COLLIDE(PAC, B, P, I, C)
%
%checks if pacman has collided with anyone....and if so, with whom
%if ghosts are blue, changes them to eyes
%
%if not, pacman dies
%
%pacman must be passed first, then all four ghosts
%program returns all four ghosts and exitnow

%get level and node dimension
lev = getappdata(gca, 'level');         %get level matrix
nodedim = get(lev, 'nodedim');

%error, pacman comes first
if ~strcmp(pac.type,'pacman')
    error('First input must be pacman')
end

exitnow = 0;

pointblue = evalin('caller','pointblue');

%check for collision with blinky
if abs(pac.node(1)-b.node(1))<=nodedim & abs(pac.node(2)-b.node(2))<=nodedim
    if strcmp(b.type, 'bghost') | strcmp(b.type, 'bbghost')
        b.type = 'eyes';
        assignin('caller','bspeed',0.5);
        set(b.graphics,'visible','off');
        set(pac.graphics,'visible','off');
        drawnow;
        th = text(pac.node(1),pac.node(2),num2str(pointblue),'color',[1 1 1],'FontWeight','Bold');
        setappdata(gca,'score',getappdata(gca,'score')+pointblue);
        assignin('caller','pointblue',2*pointblue);
        pause(0.8);
        delete(th)
        set(b.graphics,'visible','on');
        set(pac.graphics,'visible','on');
    elseif strcmp(b.type, 'eyes')
        return
    else
        exitnow = 1;
    end
end

%check for collision with pinky
if abs(pac.node(1)-p.node(1))<=nodedim & abs(pac.node(2)-p.node(2))<=nodedim
    if strcmp(p.type, 'bghost') | strcmp(p.type, 'bbghost')
        p.type = 'eyes';
        assignin('caller','pspeed',0.5);
        set(p.graphics,'visible','off');
        set(pac.graphics,'visible','off');
        drawnow;
        th = text(pac.node(1),pac.node(2),num2str(pointblue),'color',[1 1 1],'FontWeight','Bold');
        setappdata(gca,'score',getappdata(gca,'score')+pointblue);
        assignin('caller','pointblue',2*pointblue);
        pause(0.8);
        delete(th);
        set(p.graphics,'visible','on');
        set(pac.graphics,'visible','on');
    elseif strcmp(p.type, 'eyes')
        return
    else
        exitnow = 1;
    end
end

%check for collision with inky
if abs(pac.node(1)-i.node(1))<=nodedim & abs(pac.node(2)-i.node(2))<=nodedim
    if strcmp(i.type, 'bghost') | strcmp(i.type, 'bbghost')
        i.type = 'eyes';
        assignin('caller','ispeed',0.5);
        set(p.graphics,'visible','off');
        set(pac.graphics,'visible','off');
        drawnow;
        th = text(pac.node(1),pac.node(2),num2str(pointblue),'color',[1 1 1],'FontWeight','Bold');
        setappdata(gca,'score',getappdata(gca,'score')+pointblue);
        assignin('caller','pointblue',2*pointblue);
        pause(0.8);
        delete(th);
        set(p.graphics,'visible','on');
        set(pac.graphics,'visible','on');
    elseif strcmp(i.type, 'eyes')
        return
    else
        exitnow = 1;
    end
end

%check for collision with clyde
if abs(pac.node(1)-c.node(1))<=nodedim & abs(pac.node(2)-c.node(2))<=nodedim
    if strcmp(c.type, 'bghost') | strcmp(c.type, 'bbghost')
        c.type = 'eyes';
        assignin('caller','cspeed',0.5);
        set(p.graphics,'visible','off');
        set(pac.graphics,'visible','off');
        drawnow;
        th = text(pac.node(1),pac.node(2),num2str(pointblue),'color',[1 1 1],'FontWeight','Bold');
        setappdata(gca,'score',getappdata(gca,'score')+pointblue);
        assignin('caller','pointblue',2*pointblue);
        pause(0.8);
        delete(th);
        set(p.graphics,'visible','on');
        set(pac.graphics,'visible','on');
    elseif strcmp(c.type, 'eyes')
        return
    else
        exitnow = 1;
    end
end

