function B = get(ch, prop)
% 
%   get function for the character class.
%   B = GET(CH, PROP), where CH is a character 'handle'
%   -  OR - GET(CH) returns all that is getable

if nargin == 1  %if user only asks for get(CH), return all things getable
    if strcmp(ch.type,'pacman')
        fprintf(['    graphics: [ 1x2 double array ]\n\n']);
    else
        fprintf(['   color: %s\n\n'], ch.color);
    end
    fprintf(['    animation: %d\n'...
            '    currentdir: %s\n'...
            '    direction: %s\n'...
            '    node: [ 1x1 node object ]\n'...
            '    parent\n'...
            '    type: %s\n'...
            '    visible: %s\n'], ch.animation, ch.currentdir, ch.direction, ch.type, ch.visibility);
else    %use subsref to get property
    S.type = '.';
    S.subs = prop;
    B = subsref(ch, S);
end