function ch = movep(ch)
%   MOVEP(CHAN)
%   moves pacman (CHAN) to next position

if ~strcmp(get(ch, 'type'),'pacman')
    error('MOVEP is for Pacman, use MOVEG for ghosts.')
end

%extract needed data from character
currentdir = get(ch, 'currentdir');
direction = get(ch, 'direction');
animation = get(ch, 'animation');
node = get(ch, 'node');
data = getappdata(gca, 'pacman');
XData = get(ch.graphics, 'XData');
YData = get(ch.graphics, 'YData');

%do a bunch of stuff that may slow the program badly.....
lev = getappdata(gca, 'level');         %get level matrix
nodedim = get(lev, 'nodedim');

%switch statement handling when user does about face
switch currentdir   
    case 'right'
        if strcmp(direction, 'left')    %is it opposite direction
            ch.currentdir = 'left';  %change its direction
            currentdir = 'left';
            if animation==2 | animation==4  %also switch animation cases
                animation = mod(animation,4)+2;
                ch.animation = animation;
            end
        end
    case 'left'
        if strcmp(direction, 'right')
            ch.currentdir = 'right';
            currentdir = 'right';
            if animation==2 | animation==4
                animation = mod(animation,4)+2;
                ch.animation = animation;
            end
        end
    case 'up'
        if strcmp(direction, 'down')
            ch.currentdir = 'down';
            currentdir = 'down';
            if animation==2 | animation==4
                animation = mod(animation,4)+2;
                ch.animation = animation;
            end
        end
    case 'down'
        if strcmp(direction, 'up')
            ch.currentdir = 'up';
            currentdir = 'up';
            if animation==2 | animation==4
                animation = mod(animation,4)+2;
                ch.animation = animation;
            end
        end
end

ch.node = node;

if node(1)>0 & node(1)<(28*nodedim)
    %get node and position
    [n, xpos, ypos] = getnodexy(lev,node(1),node(2));   %get node
    allow = get(n, 'allow');    %find where he can turn
    
    % Get pallet (aka pellet) and eat it: 
    if animation == 1
        pallet=get(n,'pallet');
        if ~strcmp(pallet,'none');
            killpallet(lev,node(1),node(2));
            tmp = get(gcf,'child');
        end
        if strcmp(pallet,'power');
            for j='bpic'
                if ~strcmp(evalin('caller',[j '.type']),'eyes')
                    evalin('caller',[j '.type = ''bghost''; ' j 'speed = 2;']);
                end
            end
            assignin('caller','blueclock',clock);
            assignin('caller','pointblue',200);
        end
    end
else
    allow = [1 4];
    xpos = 0;
    ypos = 15;
end

%allow pacman to loop around level.
if (xpos>=28 & ypos==15) | (xpos<=1 & ypos==15)
    allow = [allow  1 4];
end

%see if pacman can turn (or keep going) when on node
directions = {'left', 'up', 'down', 'right'};
if animation==1
    if sum(allow==find(strcmp(directions,direction)))
        currentdir = direction;
        ch.currentdir=direction;
    elseif ~sum(allow==find(strcmp(directions,currentdir)))
        return
    end
end


%move the dude
animation = mod(animation,4)+1; %update animation step
ch.animation = animation;
switch currentdir
    case 'left'
        set(ch.graphics, 'CData', data(animation).left.pxl,...
                         'AlphaData', data(animation).left.alpha,...
                         'XData', XData-[0.25*nodedim 0.25*nodedim]);
        node(1) = mean(XData-[0.25*nodedim 0.25*nodedim]);
    case 'right'
        set(ch.graphics, 'CData', data(animation).right.pxl,...
                         'AlphaData', data(animation).right.alpha,...
                         'XData', XData+[0.25*nodedim 0.25*nodedim]);
        node(1) = mean(XData+[0.25*nodedim 0.25*nodedim]);
    case 'up'
        set(ch.graphics, 'CData', data(animation).up.pxl,...
                         'AlphaData', data(animation).up.alpha,...
                         'YData', YData+[0.25*nodedim 0.25*nodedim]);
        node(2) = mean(YData+[0.25*nodedim 0.25*nodedim]);
    case 'down'
        set(ch.graphics, 'CData', data(animation).down.pxl,...
                         'AlphaData', data(animation).down.alpha,...
                         'YData', YData-[0.25*nodedim 0.25*nodedim]);
        node(2) = mean(YData-[0.25*nodedim 0.25*nodedim]);
end

%sound command
switch animation
    case 1
        %sound(ch.sound{1},ch.sound{3});
    case 3
        %sound(ch.sound{2},ch.sound{3});
end

%loop pacman around
if node(1) <= -0.5*nodedim & strcmp(currentdir, 'left')
    node(1) = 28.5*nodedim;
    corn = corners(gca,node);
    set(ch.graphics, 'XData', corn{1});
elseif node(1) >= 28.5*nodedim & strcmp(currentdir, 'right')
    node(1) = -0.5*nodedim;
    corn = corners(gca,node);
    set(ch.graphics, 'XData', corn{1});
end    

ch.node = node;
tmp = get(gcf,'child');
axes(tmp(1));