function ch = subsasgn(ch, S, Value)
%   
%   Subsasgn for the character class.
%           CH.I = VALUE
%   SUBSASGN(CH, S, VALUE), where CH is the 'handle'
%   to the character object.  S is a structure with two 
%   fields: type (basically this is '.') and subs (this is
%   'I' of the above statement).  VALUE is the value to set
%   the property in question to.

if strcmp(ch.type,'pacman')  %subsasgn specific to pacman object
    %throw error if user tries to assign 'color' or 'type'
    %for pacman character (cause its irrelevent)
    if strcmp(S.subs,'color') & strcmp(S.subs,'type')
        error('Cannot set %s for a pacman character object', S.subs);
    end
else    %subsasgn specific to all ghost objects
    %nothing specific
end

directions = {'left' 'up' 'down' 'right'};

switch S.subs
    case 'visible'   %needs to set visibility of all graphics objects
        ch.visible = Value;
        set(ch.graphics,'visible',Value);
    case 'animation'    %makes sure animation is 1, 2, 3, or 4, otherwise throw error
        if (Value<1) | (Value>4) | (round(Value)~=Value)
            error('''Animation'' property must be set to 1, 2, 3, or 4');
        end
        ch = builtin('subsasgn', ch, S, Value);
    otherwise   %otherwise just get it
        ch = builtin('subsasgn', ch, S, Value);
end    