function ahan=drawlevel(l)
%AHAN=DRAWLEVEL(L)
%
%   L is a level object (has to be created first). Depending on the
%   structure of the level, this method draws the whole level and returns
%   the handle to the axes they're drawn in. Double-lines are drawn at the 
%   outer level-limits and next to VOID-nodes, all other lines match the
%   pacman-level with the superimposed grid.T

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% There used to be a ton of code here that Kai wrote for constructing
% a level, drawing it out with lines, taking a snapshot to use it as
% a bitmap.... I removed it, because it's unnecessary for the normal
% game. It may be used for writing a level editor later on, but now 
% we only have to load a static bitmap.
%
%   -Arthur
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

imdat = imread('images/pacman.jpg');
% draw the image, set all the axes and figure properties right 
i=image(imdat,'xdata',[0 28*l.nodedim],'ydata',[31*l.nodedim  0]);
set(gcf, 'position',[300 50 28*3*l.nodedim+40 31*3*l.nodedim+40],...
    'menubar','none',...
    'Renderer','zbuffer',...
    'Resize','off',...
    'color',[0 0 0]);
set(gca,'ydir','normal','XTick',[],'YTick',[],...
    'units','pixel','position',[20 20 28*3*l.nodedim 31*3*l.nodedim],...
    'XLim',[1 28*l.nodedim],'YLim',[1 31*l.nodedim]);

hold on;
bg_han=i; % get(gca,'children');
bg_img=get(bg_han,'cdata');
% class(get(get(gca, 'children'), 'cdata'))

% here's a hack fix for a weird bug that comes up 
% when you go to the next level.

% keyboard
% 
% if iscell(bg_img)
%     bg_img = bg_img{1};
% end

powmat=[0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0;
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0;
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0;
    0 0 0 0 0 0 0 1 1 1 1 0 0 0 0 0 0 0;
    0 0 0 0 0 0 1 1 1 1 1 1 0 0 0 0 0 0;
    0 0 0 0 0 1 1 1 1 1 1 1 1 0 0 0 0 0;
    0 0 0 0 1 1 1 1 1 1 1 1 1 1 0 0 0 0
    0 0 0 1 1 1 1 1 1 1 1 1 1 1 1 0 0 0;
    0 0 0 1 1 1 1 1 1 1 1 1 1 1 1 0 0 0;
    0 0 0 1 1 1 1 1 1 1 1 1 1 1 1 0 0 0;
    0 0 0 1 1 1 1 1 1 1 1 1 1 1 1 0 0 0;
    0 0 0 0 1 1 1 1 1 1 1 1 1 1 0 0 0 0;
    0 0 0 0 0 1 1 1 1 1 1 1 1 0 0 0 0 0;
    0 0 0 0 0 0 1 1 1 1 1 1 0 0 0 0 0 0;
    0 0 0 0 0 0 0 1 1 1 1 0 0 0 0 0 0 0;
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0;
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0;
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0];
power=uint8(makeimage(powmat,[255 255 255]));

palmat=[0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0;
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0;
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0;
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0;
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0;
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0;
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0;
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0;
    0 0 0 0 0 0 0 0 1 1 0 0 0 0 0 0 0 0;
    0 0 0 0 0 0 0 0 1 1 0 0 0 0 0 0 0 0;
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0;
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0;
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0;
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0;
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0;
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0;
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0;
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0];
pallet=uint8(makeimage(palmat,[255 255 255]));

% now draw all of the pellets onto the background image
for i=1:31
    for j=1:28
        t=get(l.nodes(i,j),'type');
        if strcmp(t,'TRACK')
            pal=get(l.nodes(i,j),'pallet');
            colstart=(j-1)*18+1;
            rowstart=(i-1)*18+1;
            switch pal
                case 'normal'
                    bg_img(rowstart:rowstart+17,colstart:colstart+17,:)=pallet;
                case 'power'
                    bg_img(rowstart:rowstart+17,colstart:colstart+17,:)=power;
            end
        end
    end
end
setappdata(gca,'backgorund',bg_han);
set(bg_han,'cdata',bg_img);
ahan=gca;

