function l = level(source)
%L=LEVEL(SOURCE)
%
%   Create LEVEL onject from source file
%   SOURCE is an ascii-file with entries T,B,V or G for the different types
%   of nodes in the level. The coordinates of the nodes are set here
%   automatically, the size of the level is always 31 by 28

DIM=6; % The NODE-dimension, in pixels, NODES are square 
% For drawing-reasons, the dimension has to be dividable by 2 3 and 6, so 6
% is the smallest possibility. I tried 12 - things get too big and
% therefore messy

palletcounter=0;
% I included a thing called NODEMATRIX. It'S just the matrix of all nodes
% with 0,1,2 or 3 entry. I think it's easier to have Algorithms use this.
% It's faster and makes numerical comparison possible.
l.nodematrix=zeros(31,28);
l.nodedim=DIM;
fid=fopen(source,'r');
if (fid~=-1)
    for i=1:31
        for j=1:28
            char=fscanf(fid,'%c',[1 1]);        
            if double(char)==10  % This occurs at the end of a line          
                char=fscanf(fid,'%c',[1 1]);    % Just read the next character
            end
            n=node;
            set(n,'x',(j-0.5)*DIM,'y',(31.5-i)*DIM); % sets the node coordinates (center of the node)
            switch char %determine the type of the node, set TYPE and the entry in NODEMATRIX
                case 'T'
                    set(n,'type','TRACK');
                    set(n,'pallet','normal');
                    palletcounter=palletcounter+1;
                case 'N'
                    set(n,'type','TRACK');
                case 'P'
                    set(n,'type','TRACK');
                    set(n,'pallet','power');
                    palletcounter=palletcounter+1;
                case 'B'
                    set(n,'type','BORDER');
                    l.nodematrix(i,j)=1;
                case 'V'
                    set(n,'type','VOID');
                    l.nodematrix(i,j)=2;
                case 'G'
                    set(n,'type','GHOSTBOX');
                    l.nodematrix(i,j)=3;
                case 'D'
                    set(n,'type','DOOR');
                    l.nodematrix(i,j)=4;
            end        
            l.nodes(i,j)=n;  
        end
    end 
    l.pallets=palletcounter;
    % the following loop stores all 'accessible' directins in node.allow
    for k=1:31
        for m=1:28   
            n=l.nodes(k,m); %get the node
            if strcmp(get(n,'type'),'TRACK')    % is it a 'TRACK' ?             
                nhood=getneighbourhood(l,k,m);  % look around it
                adjacents=nhood(2:2:8);         % only look at elements left/right/top/bottom
                allowmove=find(adjacents==0);   % 1=left ; 2=up ; 3=down ; 4=right
                set(n,'allow',allowmove);       % store the numerics mentioned above in node.allow
                l.nodes(k,m)=n;                 % store the node back into the level
            end
        end
    end
    l=class(l,'level');
    fclose(fid);
else
    error('Cannot open source file ''', source, ''' !');
end
