function out = splashScreen()

% This line is for silly programmers who have three versions
% OpenGL installed. Some versions don't behave properly with 
% the transparency in this function.
feature('UseGenericOpenGL',1)
quit = 0;   %decides whether to quit immediately.
% This function is an add-on to the Pacman game, so first we
% get all the info we can from the level after it is created.
ahan = gca;
l = getappdata(ahan,'level');
nodes = get(l,'nodes');
oldchildren = get(ahan,'children');
set(ahan,'color',[0 0 0]);  % set the background to black

% Now we're going to keep the level there, but turn everything
% to be invisible so that we can over-write the figure with
% the splash screen.
for k=oldchildren
    set(k,'visible','off');
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% converted the splash.bmp file to a jpeg, because
% the windows bitmap was a huge file.
splash = image(imread('images/splash.jpg'));
set(get(ahan,'parent'),'renderer','opengl','keypressfcn', @keycallback2);
set(splash,'xdata',[1 168],'ydata',[186 1]);
setappdata(get(ahan, 'parent'), 'splashpause', 1)
% Define the transparency values for each pixel of the splash screen
A = ones(650,795);
A(133:322,100:644) = 0;     % set the midsection to be transparent
set(splash,'alphadata',A);
jj = [133 180 223 274 322]; % indicies of sections to reveal, one at a time
kk = [100 184 419 644];
stopintro = 0;

for j = 1:4
    for k = 1:3
        A(jj(j):jj(j+1),kk(k):kk(k+1))=1;
        set(splash,'alphadata',A);
        if ~stopintro 
            pause(0.5);
        end
    end
end

% Because the pause function doesn't pass control to the figure
% on Unix based machines, we'll imitate the pause with another
% keypress function and a while loop
set(get(ahan, 'parent'), 'keypressfcn', @keycallback3)

while getappdata(get(ahan, 'parent'), 'splashpause') == 1
    pause(.1); % just wait until the user presses something
end

set(get(ahan,'parent'),'renderer','zbuffer');
delete(splash);
newchildren = get(ahan,'children');
for k = newchildren
    if find(k==oldchildren)
        set(k,'visible','on');
    else 
        set(k,'visible','off');
    end
end

out = quit;

function keycallback2(obj,eventData)

keypressed = double(get(obj,'currentCharacter'));

setappdata(obj, 'splashpause', 0); % this line to pass the while loop 

if isempty(keypressed)
    keypressed = 1;
end

switch keypressed
    case {113, 81} %Escape key
        %evalin('caller','evalin(''caller'', ''exitnow = 1;'')');
        evalin('caller','quit = 1;');
        evalin('caller','stopintro = 1;')
    case 13     %Enter key
         evalin('caller','stopintro = 1;');
     otherwise
         ;
 end

function keycallback3(obj, eventData)

% I don't care which button you press.. let's make it enter
keypressed = double(get(obj,'currentCharacter'));

switch keypressed
    case 13 % return
        setappdata(obj, 'splashpause', 0);
    case {113, 81}
        %evalin('caller','evalin(''caller'', ''exitnow = 1;'')');
        evalin('caller','quit = 1;');
        setappdata(obj, 'splashpause', 0);
end